package io.takima.temporalpractice.signals;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class InventoryActivityImpl implements InventoryActivity {
    private static final Logger logger = LoggerFactory.getLogger(InventoryActivityImpl.class);
    int counter;

    public InventoryActivityImpl(int inventorySize){
        this.counter = inventorySize;
    }

    @Override
    public void reserve(ConsumeSignal input) {
        int currentValue = counter;

        try {
            //Simulate async work
            Thread.sleep(10);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        counter = currentValue - 1;
        logger.info("counter: "  + counter);
    }
}
